{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Information Dialog Unit                                           }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Infodlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, EnhListView, ExtListView, ZonuClass,
  Dlghead, ExtCtrls, Main, Hzbclass, ImgList;

type
  TInfoDialog = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    dfsExtListView1: TdfsExtListView;
    dfsExtListView2: TdfsExtListView;
    Panel1: TPanel;
    Button2: TButton;
    HeaderFrame1: THeaderFrame;
    Bevel1: TBevel;
    ImageList1: TImageList;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure dfsExtListView1DblClick(Sender: TObject);
    procedure dfsExtListView2DblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    FThreadItem:  TThreadItem;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
  public
    { Public 錾 }
    procedure ClearItems;
    procedure AddThreadItem(const ActionText: string; const ImageIndex: integer;
      ThreadItem: TThreadItem);
    procedure AddRes(const ActionText: string; const ImageIndex: integer;
      Res: TRes; ThreadItem: TThreadItem);
  end;

var
  InfoDialog: TInfoDialog;

implementation

{$R *.dfm}

uses
  MonaUtils, Hzbfunc, ZonuConf;

{ TInformationDialog }

procedure TInfoDialog.AddThreadItem(const ActionText: string;
  const ImageIndex: integer;  ThreadItem: TThreadItem);
var
  Item: TListItem;
begin
  PageControl1.ActivePage :=  TabSheet1;
  Item  :=  dfsExtListView1.Items.Add;
  Item.Caption  :=  Format('%.4d', [ThreadItem.No]);
  Item.SubItems.Add(ThreadItem.Title);
  Item.SubItems.Add(ActionText);
  Item.Data :=  ThreadItem;
  Item.ImageIndex :=  ImageIndex;
  ThreadItem.AddRef;
end;

procedure TInfoDialog.AddRes(const ActionText: string; const ImageIndex: integer;
  Res: TRes; ThreadItem: TThreadItem);
var
  Item: TListItem;
begin
  PageControl1.ActivePage :=  TabSheet2;
  Item  :=  dfsExtListView2.Items.Add;
  Item.Caption  :=  Format('%.4d', [Res.No]);
  Item.SubItems.Add(TrimTag(Res.Name));
  Item.SubItems.Add(Res.Date);
  Item.SubItems.Add(ActionText);
  Item.Data     :=  Res;
  Item.ImageIndex :=  ImageIndex;
  FThreadItem   :=  ThreadItem;
end;


procedure TInfoDialog.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i:  integer;
begin

  ZonuConfig.InfoDialogPosTop   :=  Top;
  ZonuConfig.InfoDialogPosLeft  :=  Left;
  ZonuConfig.InfoDialogWidth    :=  Width;
  ZonuConfig.InfoDialogHeight   :=  Height;

  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  if  (PageControl1.ActivePage  = TabSheet1)  then  begin
    for i :=  dfsExtListView1.Items.Count - 1 downto  0 do  begin
      TThreadItem(dfsExtListView1.Items[i].Data).ReleaseRef;
      dfsExtListView1.Items.Delete(i);
    end;
  end;
end;

procedure TInfoDialog.FormActivate(Sender: TObject);
begin
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

procedure TInfoDialog.ClearItems;
begin
  dfsExtListView1.Items.Clear;
  dfsExtListView2.Items.Clear;
end;

procedure TInfoDialog.dfsExtListView1DblClick(Sender: TObject);
var
  ListDoc: TZonuListDoc;
  i: integer;
  p: TPoint;
begin
  if  (dfsExtListView1.Selected <> nil) then  begin
    if  (HotzonuWindow.GetActiveListDoc(ListDoc)) then  begin
      for i :=  0 to  HotzonuWindow.ThreadListView.Items.Count - 1  do  begin
        if  (TThreadItem(dfsExtListView1.Selected.Data) = ListDoc.ThreadItemList[i])  then  begin
          HotzonuWindow.ThreadListView.Selected :=  HotzonuWindow.ThreadListView.Items[i];
          //HotzonuWindow.ThreadListView.TopItem  :=  HotzonuWindow.ThreadListView.Items[i];
          p :=  HotzonuWindow.ThreadListView.Items[i].GetPosition;
          HotzonuWindow.ThreadListView.Scroll(p.X, p.Y - 16);
          Break;
        end;
      end;
    end;
  end;
end;

procedure TInfoDialog.dfsExtListView2DblClick(Sender: TObject);
var
  Browser: TZonuBrowser;
  i: integer;
begin
  if  (dfsExtListView2.Selected <> nil) then  begin
    if  (HotzonuWindow.GetActiveBrowser(Browser)) then  begin
      for i :=  0 to  Browser.ResList.Count - 1  do  begin
        if  (TRes(dfsExtListView2.Selected.Data) = Browser.ResList[i])  then  begin
          if  (Browser.ResList[i].Showing)  then  begin
            Browser.ScrollTo(Browser.ResList[i].No);
          end else
          if  (Browser.ResList[i].IsAboned) then  begin
            MessageDlg('w̃X͏Ă܂B', mtError, [mbOk], 0);
          end else
          if  (Browser.ResList[i].IsNG) then  begin
            MessageDlg('w̃XNG[hłB', mtError, [mbOk], 0);
          end else begin
            ShowResToDoubleWindow(FThreadItem,
                                  TRes(dfsExtListView2.Selected.Data));
          end;
          Break;
        end;
      end;
    end;
  end;
end;

procedure TInfoDialog.FormShow(Sender: TObject);
begin
  SetBounds(
    ZonuConfig.InfoDialogPosLeft,
    ZonuConfig.InfoDialogPosTop,
    ZonuConfig.InfoDialogWidth,
    ZonuConfig.InfoDialogHeight);
end;

procedure TInfoDialog.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TInfoDialog.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
end;

procedure TInfoDialog.FormDestroy(Sender: TObject);
begin
  //Action  := caFree;
end;

end.
