{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Local Folder Dialog Unit                                          }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Localdlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, ZonuClass, IniFiles,
  Dlghead;

type
  TLocalDialog = class(TForm)
    Panel2: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    TreeView1: TTreeView;
    Panel1: TPanel;
    Label1: TLabel;
    Image1: TImage;
    Edit1: TEdit;
    HeaderFrame1: THeaderFrame;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
  private
    { Private 錾 }
    FList: TList;
  public
    { Public 錾 }
    property  TargetList: TList read  FList write FList;  
  end;

var
  LocalDialog: TLocalDialog;

implementation

{$R *.dfm}

uses
  Hzbclass, ZonuConf, Hzbconst, Hzbfunc, MonaUtils, Zonutils, Boardedt;
  
procedure TLocalDialog.FormCreate(Sender: TObject);
begin
  FList           :=  TList.Create;
  Hzbfunc.BuildBoardList(TreeView1, ZonuEnviron.LocalSite);
  TreeView1.FullExpand;
  TreeView1.OnChange  :=  TreeView1Change;
end;

procedure TLocalDialog.FormDestroy(Sender: TObject);
begin
  FList.Free;
end;

procedure TLocalDialog.Button3Click(Sender: TObject);
var
  ABoard: TBoard;
  Board: TBoard;
  b : boolean;
  i : integer;  
begin
  ABoard :=  nil;
  if  (TreeView1.Selected <> nil)  then  begin
    if  (TreeView1.Selected.Data <> nil)  then  begin
      if  (TObject(TreeView1.Selected.Data) is TBoard)  then  begin
        ABoard :=  TBoard(TreeView1.Selected.Data);
      end;
    end;
  end;
  BoardEditor               :=  TBoardEditor.Create(Self);
  BoardEditor.Site          :=  ZonuEnviron.LocalSite;
  if  (ABoard <> nil)  then  begin
    BoardEditor.CategoryName  :=  ABoard.CategoryName;
  end else begin
    if  (TreeView1.Selected <> nil) then  begin
      BoardEditor.CategoryName  :=  TreeView1.Selected.Text;
    end else begin
      BoardEditor.CategoryName  :=  '';
    end;
  end;
  BoardEditor.EditMode      :=  emNew;
  if  (BoardEditor.ShowModal = mrOk)  then  begin
    Board               :=  TBoard.Create;
    Board.Site          :=  ZonuEnviron.LocalSite;
    Board.Name          :=  BoardEditor.BoardName;
    Board.BoardPath     :=  BoardEditor.BoardPath;
    Board.BoardID       :=  BoardEditor.BoardID;
    Board.Url           :=  BoardEditor.Path;
    Board.Key           :=  BoardEditor.BoardID;
    Board.Expanded      :=  True;
    Board.CategoryName  :=  BoardEditor.CategoryName;
    Board.BBS           :=  ZonuEnviron.LocalSite.BBS;
    Board.CharSet       :=  ZonuEnviron.LocalSite.CharSet;
    Board.Gaishutu      :=  False;
    b :=  False;
    for i :=  ZonuEnviron.LocalSite.BoardList.Count - 1  downto  0 do  begin
      if  (ZonuEnviron.LocalSite.BoardList[i].CategoryName = Board.CategoryName) then  begin
        ZonuEnviron.LocalSite.BoardList.Insert(i + 1, Board);
        b :=  True;
        Break;
      end;
    end;
    if  (not b) then  ZonuEnviron.LocalSite.BoardList.Add(Board);
    ZonuEnviron.LocalSite.BoardList.SaveToFile(ZonuEnviron.LocalSite.ConfigPath + FILE_BOARD);
    ZonuEnviron.LocalSite.BoardList.Clear;
    ZonuEnviron.LocalSite.LoadBoardList;
    SaveBoardListSetting(TreeView1, ZonuEnviron.LocalSite);
    BuildBoardList(TreeView1, ZonuEnviron.LocalSite);
    TreeView1.OnChange  :=  TreeView1Change;
  end;
  BoardEditor.Release;
end;

procedure TLocalDialog.FormShow(Sender: TObject);
begin
  if  (FList.Count > 0) then  begin
    Edit1.Text  :=  TThreadItem(FList[0]).Title;
    if  (FList.Count > 1) then  begin
      Edit1.Text  :=  Edit1.Text + '...';
    end;
  end else begin
    Edit1.Text  :=  '';
  end;
  Edit1.ReadOnly  :=  True;
end;

procedure TLocalDialog.Button1Click(Sender: TObject);
var
  ABoard: TBoard;
  ThreadItem: TThreadItem;
  ini: TIniFile;
  i: integer;
  s: string;
  LocalPath: string;
begin
  if  (TreeView1.Selected <> nil) then  begin
    if  (TreeView1.Selected.Data <> nil)  then  begin
      ABoard  :=  TBoard(TreeView1.Selected.Data);
      for i :=  0 to  FList.Count - 1 do  begin
        ThreadItem  :=  TThreadItem(FList[i]);
        if  (ThreadItem.DatExists) then  begin
          if  (ThreadItem.IsKakolog)  then  begin
            ThreadItem.IsKakolog     := False;
            ThreadItem.InLocalFolder := True;
            ThreadItem.SaveConfig;
          end;

          LocalPath :=  ThreadItem.LocalDatFileName;

          MoveFile(PChar(ThreadItem.LocalDatFileName),
                   PChar(ABoard.CachePath + ExtractFileName(ThreadItem.LocalDatFileName)));
          s :=  ChangeFileExt(ThreadItem.LocalDatFileName, '.inf');
          MoveFile(PChar(s),
                   PChar(ABoard.CachePath + ExtractFileName(s)));
          s :=  ChangeFileExt(ThreadItem.LocalDatFileName, '.txt');
          MoveFile(PChar(s),
                   PChar(ABoard.CachePath + ExtractFileName(s)));
          s :=  ChangeFileExt(ThreadItem.LocalDatFileName, '.bak');
          MoveFile(PChar(s),
                   PChar(ABoard.CachePath + ExtractFileName(s)));
          //
          s :=  ChangeFileExt(ThreadItem.LocalDatFileName, '.inf');
          s :=  ABoard.CachePath + ExtractFileName(s);

          ini :=  TIniFile.Create(s);
          if  (not ini.SectionExists('ORG')) then  begin
            ini.WriteString('ORG', 'SITEID', ThreadItem.Site.SiteID);
            ini.WriteString('ORG', 'BOARDID', ThreadItem.Board.BoardID);
          end;
          ini.Free;

          //
          ini :=  TIniFile.Create(ChangeFileExt(ThreadItem.LocalDatFileName, '.inf'));
          ini.WriteString('INFO', 'LOCAL', ABoard.CachePath);
          ini.Free;
        end;
      end;
      ModalResult :=  mrOk;
    end;
  end;
end;

procedure TLocalDialog.TreeView1Change(Sender: TObject; Node: TTreeNode);
begin
  if  (Node = nil)  then  begin
    Button1.Enabled :=  False;
  end else begin
    Button1.Enabled :=  (Node.Data <> nil);
  end;
end;

end.
