{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Megabbs Unit                                                      }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Megabbs;

interface

uses
  Classes, SysUtils, ZonuClass, ZonuHttp, ZonuCommon, Hzbconst, HttpProt;

type
  TMegabbsThreadList = class(TObject)
  private
    HttpCli1: THTTPCli;
    FHttpStream : TStringStream;
  public
    procedure DownloadThreadList(const Url: string;
      var ThreadItemList : TThreadItemList);
  end;

implementation

uses
  ZonuConf, MonaUtils;

{ TMegabbsThreadList }

procedure TMegabbsThreadList.DownloadThreadList(const Url: string;
  var ThreadItemList: TThreadItemList);
var
  Content:  TStringList;
  s, sx : string;
  n, m   : integer;
  No : integer;
  BoardID : string;
  DatNo : string;
  AgeCount: integer;
  ASubject : string;
  ThreadItem  : TThreadItem;
  Board : TBoard;
  i: integer;
  FMegabbsSite : TSite;
begin
  HttpCli1      :=  THTTPCli.Create(nil);
  FHttpStream   :=  TStringStream.Create('');
  if  (ZonuConfig.ProxyUse) then  begin
    HttpCli1.Proxy          :=  ZonuConfig.Proxy;
    HttpCli1.ProxyPort      :=  ZonuConfig.ProxyPort;
    HttpCli1.ProxyUsername  :=  ZonuConfig.ProxyUserName;
    HttpCli1.ProxyPassword  :=  ZonuConfig.ProxyPassword;
  end;
  HttpCli1.Agent            :=  USER_AGENT;
  FHttpStream.Position      :=  0;
  FHttpStream.Size          :=  0;
  HttpCli1.RcvdStream       :=  FHttpStream;
  HttpCli1.URL              :=  Url;
  //
  HttpCli1.Get;
  //
  if  (HttpCli1.StatusCode = 200) then  begin

    ZonuEnviron.SiteList.FindSite('megabbs', FMegabbsSite);

    Content       :=  TStringList.Create;
    Content.Text  :=  FHttpStream.DataString;
    No  :=  0;
    for i :=  0 to  Content.Count - 1 do  begin
      if  (AnsiPos('<a href="', Content[i]) = 1)  then  begin
        //<a href="./readres.cgi?bo=lobby&vi=1029553654&rm=75" target="_blank"><b>3</b>-</a><a href="#3">24ԃer`eBX^bt̂m点(21)</a>
        s :=  Copy(Content[i], AnsiPos('readres.cgi?bo=', Content[i]) + 15, Length(Content[i]));
        s :=  Copy(s, 1, AnsiPos('&', s) - 1);
        BoardID :=  s;
        s :=  Copy(Content[i], AnsiPos('&vi=', Content[i]) + 4, Length(Content[i]));
        s :=  Copy(s, 1, AnsiPos('&', s) - 1);
        DatNo :=  s;
        s :=  Copy(Content[i], AnsiPos('</a>', Content[i]) + 4, Length(Content[i]));
        s :=  Copy(s, 1, AnsiPos('</a>', s) - 1);
        //<a href="#3">24ԃer`eBX^bt̂m点(21)
        sx:=  Copy(s, AnsiPos('>', s) + 1, Length(s));
        s :=  sx;
        //
        n :=  0;
        while true  do  begin
          m :=  AnsiPos('(', sx);
          if  (m < 1) then  Break;
          n   :=  n + m;
          sx  :=  Copy(sx, n + 1, Length(sx));
        end;
        //
        ASubject  :=  DecodeHtmlEsc((Copy(s, 1, n - 1)));
        AgeCount  :=  StrToIntDef(Copy(s, n + 1, Length(s) - 1 - n), 0);
        //
        if  (FMegabbsSite.BoardList.FindBoard(BoardID, Board))  then  begin
          ThreadItem  :=  TThreadItem.Create;
          ThreadItem.CreateThreadItem(Board.Site.SiteID,
                                      Board.BoardID,
                                      DatNo,
                                      ASubject);

          ThreadItem.LoadConfig;
          ThreadItem.No         :=  No + 1;
          ThreadItem.AgeCount   :=  AgeCount;
          ThreadItemList.Add(ThreadItem);
        end;
        inc(No);
      end;
    end;
    Content.Free;
  end;
  HttpCli1.Free;
  FHttpStream.Free;
end;

end.
