{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Rebone Dialog Unit                                                }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Rebonedlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, EnhListView, ExtListView, ZonuClass,
  Dlghead, IniFiles, Menus;

type
  TReboneMode = (rmRes, rmThread);
  TReboneDialog = class(TForm)
    Button6: TButton;
    Button7: TButton;
    PageControl1: TPageControl;
    ReboneRes: TTabSheet;
    ReboneThread: TTabSheet;
    ListView1: TdfsExtListView;
    Label1: TLabel;
    ListView2: TdfsExtListView;
    Label2: TLabel;
    HeaderFrame1: THeaderFrame;
    PopupMenu1: TPopupMenu;
    AllCheck: TMenuItem;
    AllUncheck: TMenuItem;
    procedure Button7Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure AllCheckClick(Sender: TObject);
  private
    { Private 錾 }
    FReboneMode: TReboneMode;
    FThreadItem: TThreadItem;
    FResList: TResList;
  public
    { Public 錾 }
    procedure SetThreadItem(ThreadItem: TThreadItem; ResList: TResList);
    procedure AddThreadListItem(ThreadItem: TThreadItem);
    property  ReboneMode: TReboneMode   read  FReboneMode write FReboneMode;
  end;

var
  ReboneDialog: TReboneDialog;

implementation

{$R *.dfm}

uses
  MonaUtils;

{ TReboneDialog }

procedure TReboneDialog.FormCreate(Sender: TObject);
begin
  //
end;

procedure TReboneDialog.FormDestroy(Sender: TObject);
begin
  //
end;

procedure TReboneDialog.SetThreadItem(ThreadItem: TThreadItem; ResList: TResList);
var
  Item: TListItem;
  i: integer;
begin
  ReboneMode :=  rmRes;
  PageControl1.ActivePage :=  ReboneRes;
  HeaderFrame1.HeaderLabel.Caption  :=  'X̕';
  FThreadItem :=  ThreadItem;
  FResList    :=  ResList;
  for i :=  0 to  ResList.Count - 1  do  begin
    if  (ResList[i].IsAboned) and (not ResList[i].IsNG) then  begin
      Item  :=  ListView1.Items.Add;
      Item.Caption  :=  Format('%.4d', [ResList[i].No]);
      Item.SubItems.Add(TrimTag(ResList[i].Name));
      Item.SubItems.Add(ResList[i].Mail);
      Item.SubItems.Add(ResList[i].Date);
      Item.SubItems.Add(ResList[i].ID);
      Item.SubItems.Add(TrimTag(ResList[i].Body));
      Item.Data :=  ResList[i];
    end;
  end;
  ListView1.Resort;
end;

procedure TReboneDialog.Button7Click(Sender: TObject);
begin
  ModalResult :=  mrCancel;
end;

procedure TReboneDialog.Button6Click(Sender: TObject);
var
  FAbonedList: TMemIniFile;
  ThreadItem: TThreadItem;
  Res: TRes;
  i: integer;
begin
  if  (ReboneMode = rmRes)  then  begin
    FAbonedList :=  TMemIniFile.Create(ChangeFileExt(FThreadItem.LocalDatFileName, '.inf'));
    for i :=  0 to  ListView1.Items.Count - 1  do  begin
      if  (ListView1.Items[i].Checked)  then  begin
        Res :=  TRes(ListView1.Items[i].Data);
        Res.IsAboned  :=  False;
        FAbonedList.WriteBool('ERASE', 'RES' + IntToStr(Res.No), False);
      end;
    end;
    FAbonedList.UpdateFile;
    FAbonedList.Free;
    FThreadItem.LoadAbonedList;
  end else begin
    for i :=  0 to  ListView2.Items.Count - 1 do  begin
      if  (ListView2.Items[i].Checked)  then  begin
        ThreadItem  :=  TThreadItem(ListView2.Items[i].Data);
        ThreadItem.IsAboned :=  False;
        ThreadItem.SaveConfig;
      end;
    end;
  end;
  ModalResult :=  mrOk;
end;

procedure TReboneDialog.AddThreadListItem(ThreadItem: TThreadItem);
var
  Item: TListItem;
begin
  ReboneMode :=  rmThread;
  PageControl1.ActivePage :=  ReboneThread;
  Item  :=  ListView2.Items.Add;
  Item.Caption  :=  ThreadItem.Title;
  Item.SubItems.Add(ThreadItem.DatNo);
  Item.Data     :=  ThreadItem;
end;

//age16
procedure TReboneDialog.AllCheckClick(Sender: TObject);
var
  n: integer;
  ListView: TdfsExtListView;
begin
  if  (ReboneMode = rmRes)  then  begin
    ListView  :=  ListView1;
  end else begin
    ListView  :=  ListView2;
  end;
  for n :=  0 to  ListView.Items.Count - 1  do  begin
    ListView.Items[n].Checked :=  (Sender = AllCheck);
  end;
end;

end.
