{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 RSS Wizard Unit                                                   }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit RssWiz;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, HttpProt, IniFiles, ZonuClass;

type
  TRssWizard = class(TForm)
    PageControl1: TPageControl;
    TabSheet2: TTabSheet;
    Label8: TLabel;
    Label7: TLabel;
    Label10: TLabel;
    Edit2: TEdit;
    TabSheet3: TTabSheet;
    Label5: TLabel;
    Label6: TLabel;
    Label9: TLabel;
    Label11: TLabel;
    Edit1: TEdit;
    ComboBox1: TComboBox;
    TabFinal: TTabSheet;
    Label12: TLabel;
    Label13: TLabel;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    HttpCli1: THttpCli;
    RadioGroup1: TRadioGroup;
    Memo1: TMemo;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private 錾 }
    FBoard: TBoard;
    procedure AddNewSite;
    function GetRssChannelTitle: boolean;
    function GetBoardPath: string;
    function GetBoardID: string;
    function Exists(const Url: string): boolean;
  public
    { Public 錾 }
  end;

var
  RssWizard: TRssWizard;

implementation

{$R *.dfm}

uses
  ZonuConf, Hzbconst, Zonutils, MonaUtils;

procedure TRssWizard.FormCreate(Sender: TObject);
var
  i: integer;
begin
  FBoard  :=  nil;
  PageControl1.ActivePageIndex  :=  0;
  //JeSǉ
  for i :=  0 to  ZonuEnviron.RssSite.BoardList.Count - 1 do  begin
    if  (ComboBox1.Items.IndexOf(ZonuEnviron.RssSite.BoardList[i].CategoryName) < 0)  then
    begin
      ComboBox1.Items.Add(ZonuEnviron.RssSite.BoardList[i].CategoryName);
    end;
  end;
end;

procedure TRssWizard.Button2Click(Sender: TObject);
begin
  //`FbN
  if  (PageControl1.ActivePage = TabSheet2) then  begin
    if  (Edit2.Text = '') then  begin
      Edit2.SetFocus;
      Exit;
    end else
    if  (Exists(Edit2.Text))  then  begin
      MessageDlg('o^ς݂RSSTCgłB', mtError, [mbOk], 0);
      Edit2.SetFocus;
      Exit;
    end else begin
      GetRssChannelTitle;
    end;
  end else
  if  (PageControl1.ActivePage = TabSheet3) then  begin
    if  (Edit1.Text = '') then  begin
      Edit1.SetFocus;
      Exit;
    end else
    if  (ComboBox1.Text = '') then  begin
      ComboBox1.SetFocus;
      Exit;
    end;
  end;

  //////////////////////////////////////////////////////////////////////////////
  //y[W؂ւ
  if  (PageControl1.ActivePage = PageControl1.Pages[PageControl1.PageCount - 2])  then
  begin
    Button2.Caption :=  '';
  end else
  if  (PageControl1.ActivePage = TabFinal)  then  begin
    AddNewSite;
    ModalResult :=  mrOk;
    Exit;
  end;
  //////////////////////////////////////////////////////////////////////////////

  PageControl1.ActivePage :=  PageControl1.Pages[PageControl1.ActivePage.PageIndex + 1];

  //////////////////////////////////////////////////////////////////////////////
  if  (PageControl1.ActivePage = TabSheet2) then  begin
    Edit2.SetFocus;
  end else
  if  (PageControl1.ActivePage = TabSheet3) then  begin
    Edit1.SetFocus;
  end;
end;



procedure TRssWizard.Button3Click(Sender: TObject);
begin
  ModalResult :=  mrCancel;
end;

procedure TRssWizard.PageControl1Change(Sender: TObject);
begin
  if  (PageControl1.ActivePage = TabSheet2) then  begin
    Edit2.SetFocus;
  end else
  if  (PageControl1.ActivePage = TabSheet3) then  begin
    Edit1.SetFocus;
  end;
end;

procedure TRssWizard.Button1Click(Sender: TObject);
begin
  if  (PageControl1.ActivePageIndex > 0)  then  begin
    PageControl1.ActivePageIndex  :=  PageControl1.ActivePageIndex - 1;
    if  (PageControl1.ActivePage = TabSheet2) then  begin
      Edit2.SetFocus;
    end else
    if  (PageControl1.ActivePage = TabSheet3) then  begin
      Edit1.SetFocus;
    end;
  end;
end;

procedure TRssWizard.AddNewSite;
var
  Board: TBoard;
  s: string;
  b: boolean;
  i, n : integer;
begin
  Board                 :=  TBoard.Create;
  Board.Site            :=  ZonuEnviron.RssSite;
  Board.Name            :=  Edit1.Text;
  Board.BoardPath       :=  GetBoardPath;
  Board.RemoteBoardID   :=  GetBoardID;
  Board.Url             :=  Edit2.Text;
  Board.Key             :=  Board.BoardID;
  Board.Expanded        :=  True;
  Board.CategoryName    :=  ComboBox1.Text;
  Board.BBS             :=  ZonuEnviron.RssSite.BBS;
  Board.CharSet         :=  TCharSet(RadioGroup1.ItemIndex);
  Board.BoardType       :=  btRSS;
  
  //
  s :=  GetBoardID;
  n :=  1;
  i :=  0;
  while true  do  begin
    if  (i >  ZonuEnviron.RssSite.BoardList.Count - 1)  then  begin
      Board.BoardID       :=  s;
      s :=  UrlToFileName(Board.BoardPath + '_' + Board.BoardID);
      Board.CachePath     :=  ZonuConfig.CachePath + 'rss\' + s + '\';
      Break;
    end else begin
      if  (ZonuEnviron.RssSite.BoardList[i].BoardID = s) then  begin
        s :=  GetBoardID + IntToStr(n);
        Inc(n);
        i :=  0;
        Continue;
      end else begin
        Inc(i);
      end;
    end;
  end;
  b :=  False;
  for i :=  ZonuEnviron.RssSite.BoardList.Count - 1  downto  0  do  begin
    if  (ZonuEnviron.RssSite.BoardList[i].CategoryName = Board.CategoryName) then  begin
      b :=  True;
      ZonuEnviron.RssSite.BoardList.Insert(i+1, Board);
      Break;
    end;
  end;
  if  (not b) then  begin
    ZonuEnviron.RssSite.BoardList.Add(Board);
  end;
  ZonuEnviron.RssSite.BoardList.SaveToFile(ZonuEnviron.RssSite.ConfigPath + FILE_BOARD);

  //site.ini̕ҏW
  {
  b :=  False;
  for i :=  0 to  ZonuEnviron.SiteList.Count - 1  do  begin
    if  (ZonuEnviron.SiteList[0].IsInclude(GetUrl)) then  begin
      b :=  True;
      Break;
    end;
  end;

  if  (not b) then  begin
    BBS     :=  TBBS(ListBox1.Items.Objects[ListBox1.ItemIndex]);
    ini :=  TMemIniFile.Create(ZonuEnviron.UserSite.ConfigPath + INI_SITE);

    if  (SubjectTxtUrl.Text <> '')  and
        (GetIniData(BBS, GetUrl, GetBoardID, GetBoardPath, 'SUBJECT') <> SubjectTxtUrl.Text)  then
    begin
      ini.WriteString('SUBJECT', ExtractHostName(GetUrl), SubjectTxtUrl.Text);
    end;

    if  (DatUrl.Text <> '')  and
        (GetIniData(BBS, GetUrl, GetBoardID, GetBoardPath, 'DAT') <> DatUrl.Text) then
    begin
      ini.WriteString('DAT', ExtractHostName(GetUrl), DatUrl.Text);
    end;

    if  (ReadCgiUrl.Text <> '')  and
        (GetIniData(BBS, GetUrl, GetBoardID, GetBoardPath, 'READCGI') <> ReadCgiUrl.Text) then
    begin
      ini.WriteString('READCGI', ExtractHostName(GetUrl), ReadCgiUrl.Text);
    end;

    if  (SendCgiUrl.Text <> '')  and
        (GetIniData(BBS, GetUrl, GetBoardID, GetBoardPath, 'SENDCGI') <>  SendCgiUrl.Text)  then
    begin
      ini.WriteString('SENDCGI', ExtractHostName(GetUrl), SendCgiUrl.Text);
    end;

    if  (ThreadCgiUrl.Text <> '')  and
        (GetIniData(BBS, GetUrl, GetBoardID, GetBoardPath, 'NEWTHREADCGI') <> ThreadCgiUrl.Text)  then
    begin
      ini.WriteString('NEWTHREADCGI', ExtractHostName(GetUrl), ThreadCgiUrl.Text);
    end;

    ini.UpdateFile;
    ini.Free;
  end;
  }
  FBoard  :=  Board;
{
var
  BBS: TBBS;
  ini: TMemIniFile;
  s : string;
  i, n : integer;
  b : boolean;
begin
  //
  //
  //


  }
end;

function TRSSWizard.GetRssChannelTitle: boolean;
var
  ss: TStringStream;
  s: string;
begin
  Screen.Cursor :=  crHourGlass;
  ss  :=  TStringStream.Create('');
  HttpCli1.Abort;
  if  (ZonuConfig.ProxyUse) then  begin
    HttpCli1.Proxy          :=  ZonuConfig.Proxy;
    HttpCli1.ProxyPort      :=  ZonuConfig.ProxyPort;
    HttpCli1.ProxyUsername  :=  ZonuConfig.ProxyUserName;
    HttpCli1.ProxyPassword  :=  ZonuConfig.ProxyPassword;
  end;
  HttpCli1.RcvdStream       :=  ss;
  HttpCli1.Agent            :=  USER_AGENT;
  HttpCli1.URL              :=  Edit2.Text;
  try
    HttpCli1.Get;
  except
    if  (HttpCli1.StatusCode < 200) or (HttpCli1.StatusCode > 299)  then  begin
      MessageDlg('擾Ɏs܂B', mtError, [mbOk], 0);
      ss.Free;
      Screen.Cursor :=  crDefault;
      Result        :=  False;
      Exit;
    end;
  end;
  s   :=  ss.DataString;
  if  (AnsiPos('encoding="euc-jp"?', AnsiLowerCase(s)) > 0) then  begin
    RadioGroup1.ItemIndex := 1; //EUC
  end;
  s   :=  JConv(TCharSet(RadioGroup1.ItemIndex), ss.DataString);
  Edit1.Text        :=  Extract(s, '<title>', '</title>');
  Memo1.Lines.Text  :=  Extract(s, '<description>', '</description>');
  ss.Free;
  Screen.Cursor     :=  crDefault;
  Result            :=  True;
end;


procedure _Extract(const Url: string; out BoardPath, BoardID: string);
var
  s, sx:  string;
begin
  s :=  Url;
  //http://www.2ch.net/test/index.html
  if  (ExtractFileExt(ExtractUrlName(s)) <> '') then  begin
    s :=  ExtractUrlPath(s);
  end;
  //http://www.2ch.net/test/
  if  (s[Length(s)] = '/')  then  begin
    s :=  Copy(s, 1, Length(s) - 1);
  end;
  //http://www.2ch.net/test
  sx :=  Copy(ExtractUrlPath(s), 8, Length(s));
  sx :=  Copy(sx, 1, Length(sx) - 1);
  if  (sx = '') then  begin
    BoardPath :=  Copy(s, AnsiPos('://', s) + 3, Length(s));
    BoardID   :=  ExtractUrlName(Url);
  end else begin
    BoardPath :=  sx;
    BoardID   :=  ExtractUrlName(s) + '@' + ExtractUrlName(Url);
  end;
end;

function TRSSWizard.GetBoardPath: string;
var
  s:  string;
begin
  _Extract(Edit2.Text, Result, s);
end;

function TRSSWizard.GetBoardID: string;
var
  s:  string;
begin
  _Extract(Edit2.Text, s, Result);
end;


procedure TRssWizard.FormActivate(Sender: TObject);
begin
  Edit2.SetFocus;
end;

function TRssWizard.Exists(const Url: string): boolean;
var
  i: integer;
begin
  Result  :=  False;
  for i :=  0 to  ZonuEnviron.RssSite.BoardList.Count - 1 do  begin
    if  (AnsiPos(Url, ZonuEnviron.RssSite.BoardList[i].Url) = 1)  then  begin
      Result  :=  True;
      Break;
    end;
  end;
end;

end.
