unit ThrdProp;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, ZonuClass;

type
  TThreadPropertyWindow = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Button1: TButton;
    Button2: TButton;
    Image1: TImage;
    DatNo: TEdit;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Label1: TLabel;
    Path: TEdit;
    Size: TEdit;
    Label2: TLabel;
    BBSName: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    BoardName: TEdit;
    Label5: TLabel;
    URL: TEdit;
    Label6: TLabel;
    Title: TEdit;
    Label7: TLabel;
    ResCount: TEdit;
    Label8: TLabel;
    Priority: TEdit;
    Label9: TLabel;
    LastReadDate: TEdit;
    Label10: TLabel;
    LastSentDate: TEdit;
    Label11: TLabel;
    ReadCount: TEdit;
    Bevel3: TBevel;
    Label12: TLabel;
    Memo: TMemo;
    Label13: TLabel;
    DiskSize: TEdit;
    Bevel4: TBevel;
    InFavorites: TCheckBox;
    KakoLog: TCheckBox;
    InShortcutBar: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    FThreadItem: TThreadItem;
  public
    { Public 錾 }
    procedure SetThreadItem(ThreadItem: TThreadItem);
  end;

var
  ThreadPropertyWindow: TThreadPropertyWindow;

implementation

{$R *.dfm}

uses
  Hzbfunc, Hzbclass, Favdlg;

{ TThreadPropertyWindow }

procedure TThreadPropertyWindow.SetThreadItem(ThreadItem: TThreadItem);
var
  Rec: TSearchRec;
  n: integer;
begin
  FThreadItem           :=  ThreadItem;
  DatNo.Text            :=  ThreadItem.DatNo;
  Title.Text            :=  ThreadItem.Title;
  BBSName.Text          :=  ThreadItem.Site.SiteName;
  BoardName.Text        :=  ThreadItem.Board.Name;
  URL.Text              :=  ThreadItem.RemoteDatFileName;
  ResCount.Text         :=  IntToStr(ThreadItem.DownloadCount);
  Priority.Text         :=  IntToStr(ThreadItem.Priority);
  Memo.Lines.Text       :=  ThreadItem.Memo;
  LastReadDate.Text     :=  ThreadItem.LastLoadDate;
  LastSentDate.Text     :=  ThreadItem.LastSentDate;
  ReadCount.Text        :=  IntToStr(ThreadItem.LoadCount);
  Path.Text             :=  ThreadItem.LocalDatFileName;
  Size.Text             :=  Format('%d oCg (%d KB)', [ThreadItem.DatSize, ThreadItem.DatSize div 1024 + 1]);
  DiskSize.Text         :=  '';
  if  (FileExists(ThreadItem.LocalDatFileName))  then  begin
    if  (FindFirst(ThreadItem.LocalDatFileName, faAnyFile, Rec) = 0) then  begin
      DiskSize.Text  := Format('%d oCg (%d KB)', [Rec.Size, Rec.Size div 1024 + 1]);
    end;
    FindClose(Rec);
  end;
  InFavorites.Checked   :=  ThreadItem.InFavorites;
  InShortcutBar.Checked :=  ThreadItem.InShortcut;
  KakoLog.Checked       :=  ThreadItem.IsKakoLog;
end;

procedure TThreadPropertyWindow.Button1Click(Sender: TObject);
begin
  //Cɓ
  if  (FThreadItem.InFavorites) then  begin
    if  (not InFavorites.Checked) then  begin
      DeleteFromFav(FThreadItem);
      FThreadItem.InFavorites :=  False;
      FThreadItem.SaveConfig;      
    end;
  end else begin
    if  (InFavorites.Checked) then  begin
      FavoriteDialog  :=  TFavoriteDialog.Create(Self);
      FavoriteDialog.TargetList.Add(FThreadItem);
      FavoriteDialog.IsThreadItem :=  True;
      if  (FavoriteDialog.ShowModal <> mrOk) then  begin
        InFavorites.Checked :=  False;
        Exit;
      end;
    end;
  end;

  //ߋO
  if  (FThreadItem.IsKakoLog <> KakoLog.Checked)  then  begin
    FThreadItem.IsKakoLog :=  KakoLog.Checked;
    FThreadItem.SaveConfig;
  end;

  //
  ModalResult :=  mrOk;
end;

procedure TThreadPropertyWindow.Button2Click(Sender: TObject);
begin
  ModalResult :=  mrCancel;
end;

end.
