{ *************************************************************************** }
{                                                                             }
{ Hotzonu The BBS Script Unit                                                 }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit ZonuThebbs;

interface

uses
  Classes, SysUtils, ZonuClass, ZonuCommon, ZonuHttp, Hzbconst, HttpProt, Forms,
  Dialogs, Controls, IniFiles;

type
  PParamData  = ^TParamData;
  TParamData  = record
    Check01: boolean; //
  end;

  TTheBBSScript = class(TBBS)
  private
  protected
    function GetThreadListType: TThreadListAccessType; override;
    function GetThreadDownloadMode: TThreadDownloadMode; override;
    function GetNeedHRefLink: boolean; override;
    function GetNeedLinkTarget: boolean; override;
    function GetRelativeLink: boolean; override;
    function GetIsPublished: boolean; override;
  public
    function  GetDisplayUrl(ThreadItem: TThreadItem): string; override;
    procedure DownloadThreadList(Downloader: TThreadListDownloader;
      const NoCache, ASync, InfSave: boolean); override;
    procedure DownloadThreadItem(Downloader: TResDownloader;
        const NoCache, ASync, InfSave, AutoPilot: boolean); override;
    procedure ParseSubject(subject: string; out FileName: string;
      out Title: string; out Count: integer); override;
    procedure ParseDat(const ALine: string; const index: integer;
      var ARes: TRes; out ASubject: string); override;
    procedure SendRes(Uploader: TResUploader); override;
    procedure SendThread(Uploader: TThreadUploader); override;
  end;

implementation

uses
  Zonutils, ZonuConf, MonaUtils;

{ TTheBBSScript }

//
//  Xbhꗗ̎擾@
//
function TTheBBSScript.GetThreadListType: TThreadListAccessType;
begin
  Result  :=  tlLump;
end;

//
//  Xbh̎擾@
//
function TTheBBSScript.GetThreadDownloadMode: TThreadDownloadMode;
begin
  Result  :=  dmText;
end;

//
//  http://ւ̃Nǉ
//
function TTheBBSScript.GetNeedHRefLink: boolean;
begin
  Result  :=  True;
end;

//
//  NւTarget=_blankǉ
//
function TTheBBSScript.GetNeedLinkTarget: boolean;
begin
  Result  :=  False;
end;

//
//  BBSEBU[hŕ\邩ǂ
//
function TTheBBSScript.GetIsPublished: boolean;
begin
  Result  :=  True;
end;

//
//  Xbhꗗ_E[h
//
procedure TTheBBSScript.DownloadThreadList(
  Downloader: TThreadListDownloader; const NoCache, ASync,
  InfSave: boolean);
var
  ParamData : PParamData;
  FZonuHttp : TZonuHttp;
begin
  New(ParamData);
  Downloader.ParamData      :=  ParamData;
  FZonuHttp                 :=  TZonuHttp.Create(nil);
  FZonuHttp.Downloader      :=  Downloader;
  FZonuHttp.OnZonuData      :=  ZonuDataThreadList;
  FZonuHttp.OnZonuEnd       :=  ZonuEndThreadList;
  FZonuHttp.OnZonuError     :=  ZonuThreadListError;
  FZonuHttp.Url             :=  GetSubjectUrl(Downloader.Board);
  FZonuHttp.NoCache         :=  NoCache;
  FZonuHttp.UserAgent       :=  DolibManager.UserAgent;
  FZonuHttp.NeedDataEvent   :=  False;
  FZonuHttp.AcceptEncoding  :=  'gzip';
  FZonuHttp.InfSave         :=  InfSave;
  FZonuHttp.Username        :=  Downloader.Board.BasicAuthorization_UserName; //8
  FZonuHttp.Password        :=  Downloader.Board.BasicAuthorization_Password; //8
  FZonuHttp.GetModified(Downloader.Board.CachePath + 'subject.inf', ASync);
end;

//
//  Xbhꗗ擾
//
procedure TTheBBSScript.ZonuDataThreadList(Sender: TObject;
  Downloader: TDownloader; Data: string; TotalSize,
  DownloadSize: integer; var MoreData: boolean);
var
  dl        : TThreadListDownloader;
  AFileName : string;
  ATitle    : string;
  ACount    : integer;
  ThreadItem: TThreadItem;
begin
  inherited;
  dl  :=  TThreadListDownloader(Downloader);
  ParseSubject(Data, AFileName, ATitle, ACount);
  ThreadItem                    :=  TThreadItem.Create;
  ThreadItem.BBS                :=  Self;
  ThreadItem.Site               :=  dl.Site;
  ThreadItem.BoardID            :=  dl.Board.BoardID;
  ThreadItem.No                 :=  0;
  ThreadItem.DatFileName        :=  AFileName;
  ThreadItem.Title              :=  ATitle;
  ThreadItem.AgeCount           :=  ACount;
  ThreadItem.RemoteDatFileName  :=  GetDatUrl(dl.Board, AFileName);
  ThreadItem.LocalDatFileName   :=  dl.Board.CachePath + AFileName;
  dl.FireDataEvt(ThreadItem, DownloadSize, TotalSize, MoreData);
end;

procedure TTheBBSScript.DownloadThreadItem(Downloader: TResDownloader;
  const NoCache, ASync, InfSave, AutoPilot: boolean);
begin
  inherited;

end;

function TTheBBSScript.GetDisplayUrl(ThreadItem: TThreadItem): string;
begin

end;

function TTheBBSScript.GetRelativeLink: boolean;
begin

end;

procedure TTheBBSScript.ParseDat(const ALine: string; const index: integer;
  var ARes: TRes; out ASubject: string);
begin
  inherited;

end;

procedure TTheBBSScript.ParseSubject(subject: string; out FileName,
  Title: string; out Count: integer);
begin
  inherited;

end;

procedure TTheBBSScript.SendRes(Uploader: TResUploader);
begin
  inherited;

end;

procedure TTheBBSScript.SendThread(Uploader: TThreadUploader);
begin
  inherited;

end;

end.
